#include "SADB.h"
using namespace SADB;

//Some Basic Functions

/// Convert a u8 to the BODataType equivalent
/// @param Type
///   Integer representation of the data type
/// @return
///   enum
BODataType SADB::DataTypeIntToEnum(SADBu8 Type){
 switch(Type){
  case 0x00: return BOByte;break;
  case 0x01: return BOInteger;break;
  case 0x02: return BOFloat;break;
  case 0x03: return BODouble;break;
  default:   return BOByte;//Default to single byte
 }
}

/// Convert a BODataType to the int equivalent
/// @param Type
///   BODataType object
/// @return
///   int
int SADB::DataTypeEnumToInt(BODataType Type){
 switch(Type){
  case BOByte: return 0x00;break;
  case BOInteger: return 0x01;break;
  case BOFloat: return 0x02;break;
  case BODouble: return 0x03;break;
  default:   return 0x00;//Default to single byte
 }
}



/// Exit program and display an error message
/// @param[in] Title
///   Error name
/// @param[in] Description
///   Error name
void SADB::Error(const char *Title,const char *Description){
 printf("###########################\n");
 printf("########!!!ERROR!!!########\n");
 printf("###########################\n");
 printf("%s\n",Title);
 printf("%s\n",Description);
 exit(0);
}






#ifdef WINDOWS
/// emulates usleep from unistd.h, rounds to millisecond
/// @param len
///   length in micro seconds
void SADB::usleep(SADBu64 len){
 Sleep((DWORD)len/1000);
}
#endif 
