#include "SADB.h"
using namespace SADB;

#ifdef POSIX

NanoTimer::NanoTimer(void){Start();}
NanoTimer::~NanoTimer(void){}

/// Start the timer
void NanoTimer::Start(void){
 clock_gettime(CLOCK_MONOTONIC,&A);
}

/// Returns the number of nanoseconds elapsed since the timer was started
/// @return nanoseconds
long NanoTimer::Stop(void){
 clock_gettime(CLOCK_MONOTONIC,&B);
 long TA=(long)A.tv_sec*1000000000+A.tv_nsec;
 long TB=(long)B.tv_sec*1000000000+B.tv_nsec;
 return TB-TA;
}

/// Prints the number of nanoseconds elapsed since the timer was started
void NanoTimer::Print(void){
 clock_gettime(CLOCK_MONOTONIC,&B);
 long TA=(long)A.tv_sec*1000000000+A.tv_nsec;
 long TB=(long)B.tv_sec*1000000000+B.tv_nsec;
 printf("%ld\n",TB-TA);
}

/// Prints the inverse (1/x) of number of nanoseconds elapsed since the timer was started, good to measure frequencies
void NanoTimer::PrintInverse(void){
 clock_gettime(CLOCK_MONOTONIC,&B);
 long TA=(long)A.tv_sec*1000000000+A.tv_nsec;
 long TB=(long)B.tv_sec*1000000000+B.tv_nsec;
 printf("%lf\n",(double)1/((double)(TB-TA)/1000000000));
}

/// Prints the inverse (1/x) of number of nanoseconds elapsed since the timer was started, good to measure frequencies
/// @param time 
///  Wait until this amount of time has elapsed since styarting the timer
void NanoTimer::WaitUntil(long time){
 clock_gettime(CLOCK_MONOTONIC,&B);
 long TA=(long)A.tv_sec*1000000000+A.tv_nsec;
 long TB=(long)B.tv_sec*1000000000+B.tv_nsec;
 while(TB-TA<time){
  clock_gettime(CLOCK_MONOTONIC,&B);
  TA=(long)A.tv_sec*1000000000+A.tv_nsec;
  TB=(long)B.tv_sec*1000000000+B.tv_nsec;
 }
}

#endif

