
#ifndef __NETWORK__
#define __NETWORK__

#define MAXFORMATTEDLENGTH 500

class Network {
 public:
  Network(void);
  ~Network(void);
  void Close(void);

  void Server(int port,int MaxQueue);
  int ConnectTo(const char * address,int port);
  int WaitForConnection(void);

  int Receive(unsigned char * Buffer,int MaxLength);
  int ReceiveExactly(unsigned char * Buffer,int Length);
  int Send(unsigned char * Buffer);
  int Send(unsigned char * Buffer,int Length);
  int Sendf(unsigned char *format,...);

  /// Socket Descriptor
  int Socket;
  /// Port Number
  int Port;

 private:
  struct addrinfo *AddressInfo;
  pthread_mutex_t Mutex;
};

//General socket communication functions
int SocketReceive(int Socket,unsigned char * Buffer,int MaxLength);
int SocketReceiveExactly(int Socket,unsigned char * Buffer,int Length);
int SocketSend(int Socket,unsigned char * Buffer,size_t Length);
int SocketSend(int Socket,unsigned char * Buffer);
int SocketSendf(int Socket,unsigned char *format,...);


#endif 
