#ifndef __SADB__
#define __SADB__

#ifdef WIN32
#ifndef WINDOWS
#define WINDOWS //if compiling with MSVC++
#endif
#else
#define POSIX //if compiling on a posix system
#endif

//Common C Includes
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <sys/timeb.h>
#include <math.h>

#ifdef POSIX
 #include <unistd.h>
 #include <sys/time.h>
 #include <sys/stat.h>
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <netinet/tcp.h>
 #include <arpa/inet.h>
 #include <netdb.h>
 #include <fcntl.h>

 #define INVALID_SOCKET -1
 #define SOCKET_ERROR -1

 #include "NanoTimer.h"

#endif


extern "C" {
//#include <png.h>//Windows: Make sure you the png.h file is in your path
#include <pthread.h>
}

#ifdef WIN32
#include <winsock2.h>
#include <ws2tcpip.h>
#pragma comment(lib,"Ws2_32.lib")
#endif

namespace SADB{

#define SADBPort	8081
#define SADBAddress	"192.168.1.10" 

	typedef long long unsigned int Pointer;//size of a memory address (long for 64 bits system, int for 32 bit systems) this is needed for MSVC++ to compile

	//Type Definitions
	typedef unsigned char		SADBu8;
	typedef signed char		SADBs8;
	typedef unsigned short		SADBu16;
	typedef signed short		SADBs16;
	typedef unsigned int		SADBu32;
	typedef signed int		SADBs32;
	typedef unsigned long long int	SADBu64;
	typedef signed long long int	SADBs64;
	typedef float			SADBfl;
	typedef double			SADBdfl;

	enum BODataType { BOByte=0x00, BOInteger=0x01, BOFloat=0x02, BODouble=0x03 };//For now...


#include "Basics.h"
#include "Timestamp.h"
#include "Network.h"
#include "NetPackets.h"
#include "BlackboardObject.h"
#include "Blackboard.h"
#include "BlackboardObjectListener.h"

#include "SpecializedClasses/SADBStringTable.h"

}

#endif //__SADB_


