#ifndef __Basics__
#define __Basics__

//Type Definitions
typedef unsigned char		u8;
typedef signed char		s8;
typedef unsigned short		u16;
typedef signed short		s16;
typedef unsigned int		u32;
typedef signed int		s32;
typedef unsigned long long int	u64;
typedef signed long long int	s64;
typedef float			fl;
typedef double			dfl;

typedef long Pointer;//size of a memory address (long for 64 bits system, int for 32 bit systems) this is needed for MSVC++ to compile

struct Timestamp {u64 Second;u16 Millisecond;};

enum BODataType { Byte=0x00, Integer=0x01, Float=0x02, Double=0x03 };//For now...
BODataType DataTypeIntToEnum(u8 Type);

void Log(const char*Format,...);
void GetTimestamp(Timestamp & TS);
void PrintTimestamp(Timestamp & TS);
u64 TimestampToMilliseconds(Timestamp & A);
s64 TimestampDifference(Timestamp&A,Timestamp&B);
s64 TimestampDifference(Timestamp*A,Timestamp*B);
s64 TimestampDifference(u64 SecondA,u16 MillisecondA,u64 SecondB,u16 MillisecondB);
void Error(const char *Title,const char *Description);


#endif 
