int HTTPFileExists(u8 * Filename);
void HTTPMIME(u8 * Filename,u8 * MIME);
void HTTPSendFile(int Socket,u8*Request);
void HTTPSend404(int Socket);
int HTTPRequestValid(u8* Request);
void HTTPHeader(u8** Buffer);
void HTTPFooter(u8** Buffer);





/// Check to make sure request is valid (no ../)
/// @param Request
///  String to be checked
/// @return 0 if invalid
int HTTPRequestValid(u8* Request){
 if(strstr((const char *)Request,"..")!=NULL)return 0;//Make sure not exiting Data Folder
 else return 1;
}

/// Send a 404 Error Message
/// @param Socket
///  Target Socket
void HTTPSend404(int Socket){
 time_t Time;time(&Time);
 CorkSocket(Socket);
 SocketSend(Socket,"HTTP/1.0 404 Not Found\n");
 SocketSend(Socket,"Date: ");SocketSend(Socket,ctime(&Time));
 SocketSend(Socket,"Content-Type: text/html\n");
 SocketSend(Socket,"Content-Length: 35\n\n");
 SocketSend(Socket,"<html><body>Not Found</body></html>\n");
 UncorkSocket(Socket);
}

/// Send a file
/// @param Socket
///  Target Socket
/// @param Request
///  Resquested file
void HTTPSendFile(int Socket,u8*Request){
 //Generate filename and open file
 char *TMPBuffer=(char*)malloc(500);
 sprintf(TMPBuffer,"%s%s",HTTPData,Request);
 FILE *File=fopen((const char *)TMPBuffer,"rb");
 free(TMPBuffer);//Deallocate filename string
 //Read File
 fseek(File,0,SEEK_END);size_t Size=ftell(File);rewind(File);//Get File Size
 u8*Data=(u8*)malloc(Size);//Allocate buffer
 fread(Data,1,Size,File);//Read Data from file
 fclose(File);//Close File
 //Get MIME Type of the file
 u8* MIME=(u8*)malloc(40);
 HTTPMIME(Request,MIME);
 time_t Time;time(&Time);
 CorkSocket(Socket);
 SocketSend(Socket,"HTTP/1.0 200 OK\n");
 SocketSend(Socket,"Date: ");SocketSend(Socket,ctime(&Time));
 SocketSend(Socket,"Content-Type: ");SocketSend(Socket,(const char*)MIME);SocketSend(Socket,"\n\n");
 SocketSend(Socket,Data,Size);
 UncorkSocket(Socket);
 free(Data);free(MIME);//Free memory
}




/// Get MIME type of a file, based on the extension
/// @param Filename
///  Filename
/// @param MIME
///  Returned MIME type
void HTTPMIME(u8 * Filename,u8 * MIME){
 u8 Ext[3];
 int l=strlen((const char *)Filename);
 Ext[0]=*(Filename+l-3);
 Ext[1]=*(Filename+l-2);
 Ext[2]=*(Filename+l-1);
      if((Ext[0]=='j')&&(Ext[1]=='p')&&(Ext[2]=='g'))sprintf((char*)MIME,"image/jpeg");
 else if((Ext[0]=='p')&&(Ext[1]=='e')&&(Ext[2]=='g'))sprintf((char*)MIME,"image/jpeg");
 else if((Ext[0]=='g')&&(Ext[1]=='i')&&(Ext[2]=='f'))sprintf((char*)MIME,"image/gif");
 else if((Ext[0]=='p')&&(Ext[1]=='n')&&(Ext[2]=='g'))sprintf((char*)MIME,"image/png");
 else if((Ext[0]=='s')&&(Ext[1]=='v')&&(Ext[2]=='g'))sprintf((char*)MIME,"image/svg+xml");
 else if((Ext[0]=='i')&&(Ext[1]=='f')&&(Ext[2]=='f'))sprintf((char*)MIME,"image/tiff");
 else if((Ext[0]=='i')&&(Ext[1]=='c')&&(Ext[2]=='o'))sprintf((char*)MIME,"image/vnd.microsoft.icon");
 else if((Ext[0]=='c')&&(Ext[1]=='s')&&(Ext[2]=='s'))sprintf((char*)MIME,"text/css");
 else if((Ext[0]=='h')&&(Ext[1]=='t')&&(Ext[2]=='m'))sprintf((char*)MIME,"text/html");
 else if((Ext[0]=='t')&&(Ext[1]=='m')&&(Ext[2]=='l'))sprintf((char*)MIME,"text/html");
 else if((Ext[0]=='.')&&(Ext[1]=='j')&&(Ext[2]=='s'))sprintf((char*)MIME,"application/javascript");
 else if((Ext[0]=='t')&&(Ext[1]=='x')&&(Ext[2]=='t'))sprintf((char*)MIME,"text/plain");
 else if((Ext[0]=='x')&&(Ext[1]=='m')&&(Ext[2]=='l'))sprintf((char*)MIME,"text/xml");
 else sprintf((char*)MIME,"text/plain");//Default to raw text
}





///
/// Check to see if file exists in the HTTPData Folder
/// @param[in] Filename
///   Name of file
/// @return 1 if file exists, 0 otherwise
///
int HTTPFileExists(u8 * Filename){
 char *TMPBuffer=(char *)malloc(500);
 sprintf(TMPBuffer,"%s%s",HTTPData,Filename);
 int r=0;
 struct stat Stat;
 if(stat(TMPBuffer,&Stat)>=0)r=1;
 free(TMPBuffer);
 return r;
}


/// Generate a Basic Page Header
void HTTPHeader(int Socket){
 time_t Time;time(&Time);
 CorkSocket(Socket);
 SocketSend(Socket,"HTTP/1.0 200 OK\n");
 SocketSend(Socket,"Date: ");SocketSend(Socket,ctime(&Time));
 SocketSend(Socket,"Content-Type: text/html\n\n");
 SocketSend(Socket,"<html><head><link rel=\"stylesheet\" type=\"text/css\" href=\"main.css\"/></head><body>\n");
}


/// Generate a Basic Page Footer
void HTTPFooter(int Socket){
 SocketSend(Socket,"</body></html>\n");
 UncorkSocket(Socket);
}


void HTTPSimpleMessage(int Socket,const char*Message){
 HTTPHeader(Socket);
 SocketSendf(Socket,"%s\n",Message);
 HTTPFooter(Socket);
}