void HTTPListCategories(int Socket,SADBServer * SADB){
 HTTPHeader(Socket);
 SocketSend(Socket,"<h1>List of Categories</h1>");
 pthread_mutex_lock(&(SADB->CategoryAllocationMutex));
 for(u64 i=0;i<SADB->nCategories;i++)if(SADB->CategoryStates[i]==1){//if active
   SocketSend(Socket,"<div class=\"Element\">");
   pthread_mutex_lock(&((SADB->Categories[i])->InfoMutex));
    SocketSendf(Socket,"<a href=\"categoryinfo?%lld\"><div class=\"Element-MoreInfo\">More<br>Info</div></a>",(SADB->Categories[i])->ID);
    SocketSendf(Socket,"<div class=\"Element-ID-Name\"><tt>0x%016llx</tt><span>%s</span></div>",(SADB->Categories[i])->ID,(SADB->Categories[i])->Name);
    SocketSendf(Socket,"<div class=\"Element-Description\">%s</div>",(SADB->Categories[i])->Description);
   pthread_mutex_unlock(&((SADB->Categories[i])->InfoMutex));
   SocketSend(Socket,"</div>");
 }
 pthread_mutex_unlock(&(SADB->CategoryAllocationMutex));
 HTTPFooter(Socket);
}




void HTTPCategoryInfo(int Socket,SADBServer * SADB,unsigned char * Request){
 u64 ID=atol((const char *)(Request+14));//offset to remove string before ?
 if(ID>SADB->nCategories){HTTPSend404(Socket);return;}
 if(SADB->CategoryStates[ID-1]!=1){HTTPSend404(Socket);return;}
 
 pthread_mutex_lock(&(SADB->CategoryAllocationMutex));
 SADBCategory*Category=(SADB->Categories)[ID-1];
 pthread_mutex_unlock(&(SADB->CategoryAllocationMutex));
 
 HTTPHeader(Socket);
 SocketSend(Socket,"<h1>Category Information</h1><h2>General Information</h2>");

 pthread_mutex_lock(&(Category->InfoMutex));
  SocketSendf(Socket,"<b>Category ID:</b>0x%08llX<br>",Category->ID);
  SocketSendf(Socket,"<b>Category Name:</b>%s<br>",Category->Name);
  SocketSendf(Socket,"<b>Category Description:</b>%s<br><br><br>",Category->Description);
 pthread_mutex_unlock(&(Category->InfoMutex));

 pthread_mutex_lock(&(Category->DataAllocationMutex));
 if(Category->nObjects>0){
  SocketSend(Socket,"<h2>Category Members:</h2><ul>");
  for(int i=0;i<Category->nObjects;i++){
   u64 ID=Category->ObjectIDs[i];
   SADBObject*Object=(SADB->Objects)[ID-1];
   if(Object!=NULL){
    pthread_mutex_lock(&(Object->InfoMutex));
     SocketSendf(Socket,"<li><tt><a href=\"objectinfo?%lld\">0x%08llx</a></tt> - %s</li>",ID,ID,Object->Name);
    pthread_mutex_unlock(&(Object->InfoMutex));
   }
  }
  SocketSend(Socket,"</ul>");
 }
 pthread_mutex_unlock(&(Category->DataAllocationMutex));

 HTTPFooter(Socket);
}


