void HTTPListObjects(int Socket,SADBServer * SADB){
 HTTPHeader(Socket);
 SocketSend(Socket,"<h1>List of Objects</h1>");
 pthread_mutex_lock(&(SADB->ObjectAllocationMutex));
 for(u64 i=0;i<SADB->nObjects;i++)if(SADB->ObjectStates[i]==1){//if active
  SocketSend(Socket,"<div class=\"Element\">");
  pthread_mutex_lock(&((SADB->Objects[i])->InfoMutex));
   SocketSendf(Socket,"<a href=\"objectinfo?%lld\"><div class=\"Element-MoreInfo\">More<br>Info</div></a>",(SADB->Objects[i])->ID);
   SocketSendf(Socket,"<div class=\"Element-ID-Name\"><tt>0x%016llx</tt><span>%s</span></div>",(SADB->Objects[i])->ID,(SADB->Objects[i])->Name);
   SocketSendf(Socket,"<div class=\"Element-Description\">%s</div>",(SADB->Objects[i])->Description);
  pthread_mutex_unlock(&((SADB->Objects[i])->InfoMutex));
  SocketSend(Socket,"</div>");
 }
 pthread_mutex_unlock(&(SADB->ObjectAllocationMutex));
 HTTPFooter(Socket);
}




void HTTPObjectInfo(int Socket,SADBServer * SADB,unsigned char * Request){
 u64 ID=atol((const char *)(Request+12));//offset to remove string before ? 
 if(ID>SADB->nObjects){HTTPSend404(Socket);return;}
 if(SADB->ObjectStates[ID-1]!=1){HTTPSend404(Socket);return;}
 
 pthread_mutex_lock(&(SADB->ObjectAllocationMutex));
 SADBObject*Object=(SADB->Objects)[ID-1];
 pthread_mutex_unlock(&(SADB->ObjectAllocationMutex));
 
 HTTPHeader(Socket);
 SocketSend(Socket,"<h1>Object Information</h1><h2>General Information</h2>");
 

 pthread_mutex_lock(&(Object->InfoMutex));
  SocketSendf(Socket,"<b>Object ID:</b>0x%08llX<br>",Object->ID);
  SocketSendf(Socket,"<b>Object Name:</b>%s<br>",Object->Name);
  SocketSendf(Socket,"<b>Object Description:</b>%s<br>",Object->Description);
 pthread_mutex_unlock(&(Object->InfoMutex));

 //Print the number of timestamps and retrieve latest value
 SADBObjectStorage*Latest=NULL;
 pthread_mutex_lock(&(Object->DataAllocationMutex));
  SocketSendf(Socket,"<b>Timestamps: %d</b><br>",Object->nValues);
  if(Object->nValues>0)Latest=(Object->Values)[Object->nValues-1];
 pthread_mutex_unlock(&(Object->DataAllocationMutex));
  
 if(Latest!=NULL){
  SocketSend(Socket,"<h2>Latest Value</h2>");

  pthread_mutex_lock(&(Latest->Mutex));

   time_t Second=Latest->Time.Second;

   struct tm*HRTimeStamp=localtime(&Second);
   SocketSendf(Socket,"<b>Timestamp:</b> %s ( %lld.%d )<br>",asctime(HRTimeStamp),Latest->Time.Second,Latest->Time.Millisecond);
   SocketSend(Socket,"<b>Dimensions:</b>");
   for(int i=0;i<Latest->Dimensionality-1;i++)SocketSendf(Socket,"%d x ",Latest->Dimensions[i]);
   SocketSendf(Socket,"%d",Latest->Dimensions[Latest->Dimensionality-1]);
   SocketSend(Socket,"<br><b>Data Type: </b>");

   switch(Latest->DataType){//Convert data at given memory location to proper type
    case Byte:		SocketSend(Socket,"Byte\n");break;
    case Integer:	SocketSend(Socket,"Integer\n");break;
    case Float:		SocketSend(Socket,"Float\n");break;
    case Double:	SocketSend(Socket,"Double\n");break;
    default:		SocketSend(Socket,"Defaulted to Byte\n");break;
   }
   
   SocketSendf(Socket,"<br><br><b>Latest Value:</b><br><a href=\"objectvalue?%lld\">Download</a><br>",ID);

   //Print the latest value
   if(Latest->TotalNumberOfElements<1000){
    Pointer p=(Pointer)Latest->Data;
    for(int i=0;i<Latest->TotalNumberOfElements;i++){
     switch(Latest->DataType){//Convert data at given memory location to proper type
      case Byte:	SocketSendf(Socket,"%03d ",*((u8*)p));p+=1;break;
      case Integer:	SocketSendf(Socket,"%d ",*((u32*)p));p+=4;break;
      case Float:	SocketSendf(Socket,"%f ",*((fl*)p));p+=4;break;	
      case Double:	SocketSendf(Socket,"%lf ",*((dfl*)p));p+=8;break;	
      default:		SocketSendf(Socket,"%03d ",*((u8*)p));p+=1;break;
     }
     if((Latest->Dimensionality==2)&&((i+1)%Latest->Dimensions[1]==0))SocketSend(Socket,"<br>");
    }
   }
  
  pthread_mutex_unlock(&(Latest->Mutex));
 }
 SocketSendf(Socket,"<br><br>");

 HTTPFooter(Socket);

}





void HTTPObjectValue(int Socket,SADBServer * SADB,unsigned char * Request){
 u64 ID=atol((const char *)(Request+13));//offset to remove string before ?
 if(ID>SADB->nObjects){HTTPSend404(Socket);return;}
 if(SADB->ObjectStates[ID-1]!=1){HTTPSend404(Socket);return;}
 pthread_mutex_lock(&(SADB->ObjectAllocationMutex));
 SADBObject*Object=(SADB->Objects)[ID-1];
 pthread_mutex_unlock(&(SADB->ObjectAllocationMutex));
 if(Object->nValues<1){HTTPSend404(Socket);return;}//No values'
 
 //Get the value
 pthread_mutex_lock(&(Object->DataAllocationMutex));
 SADBObjectStorage*Value=(Object->Values)[Object->nValues-1];
 pthread_mutex_unlock(&(Object->DataAllocationMutex));
 
 //Prepare the packet
 pthread_mutex_lock(&(Value->Mutex));
 
 time_t Time;time(&Time);
 CorkSocket(Socket);
 SocketSend(Socket,"HTTP/1.0 200 OK\n");
 SocketSend(Socket,"Date: ");SocketSend(Socket,ctime(&Time));
 SocketSend(Socket,"Content-Type: application/octet-stream\n\n");
 SocketSend(Socket,(unsigned char *)Value->Data,Value->TotalNumberOfElements*Value->ElementSize);
 
 pthread_mutex_unlock(&(Value->Mutex));
 UncorkSocket(Socket);

}










