#define MaxFileSize 1000000 //~1MB max html page size
#include "Basics.cpp"
#include "Objects.cpp"
#include "Categories.cpp"
#include "Status.cpp"
#include "Admin.cpp"


/// Respond to an HTTP Request
/// @param Socket
///  Socket to dend data
/// @param Request
///  String containing the requested page including the ?...
void HTTPAnswer(int Socket,unsigned char * Request,SADBServer * SADB){
 if(!HTTPRequestValid(Request)){HTTPSend404(Socket);return;}//Make sure the request is valid
 if(strcmp((const char *)Request,"/")==0)sprintf((char*)Request,"/index.html");// '/' goes to index.html

 u8* request=NULL;

 const char *i=strchr((const char *)Request,'?');
 if(i!=NULL){//There is an argument
  request=(u8*)malloc(60);
  if(request==NULL)return;
  memcpy(request,Request,(u64)i-(u64)Request);
  request[(u64)i-(u64)Request]='\0';
 }


 

 //Handle Special Pages
 if(strcmp((const char *)Request,"/status")==0)HTTPStatus(Socket,SADB);
 else if(strcmp((const char *)Request,"/reset")==0){Log("Reset From HTTP");SADB->Reset();HTTPStatus(Socket,SADB);}
 else if(strcmp((const char *)Request,"/listobjects")==0)HTTPListObjects(Socket,SADB);
 else if(strcmp((const char *)Request,"/listcategories")==0)HTTPListCategories(Socket,SADB);
 else if(strcmp((const char *)Request,"/admin")==0)HTTPAdmin(Socket,SADB);
 else if(request!=NULL){
  if(strcmp((const char *)request,"/objectinfo")==0)HTTPObjectInfo(Socket,SADB,Request);
  else if(strcmp((const char *)request,"/objectvalue")==0)HTTPObjectValue(Socket,SADB,Request);
  else if(strcmp((const char *)request,"/categoryinfo")==0)HTTPCategoryInfo(Socket,SADB,Request);
  else if(strcmp((const char *)request,"/dump")==0)HTTPDump(Socket,SADB,Request);
  else if(strcmp((const char *)request,"/load")==0)HTTPLoad(Socket,SADB,Request);
 }
 else if(HTTPFileExists(Request))HTTPSendFile(Socket,Request);//General Files
 else HTTPSend404(Socket);//Send not found otherwise

 free(request);
}




