#include "SADB.hpp"
#include "HTTP/main.cpp"

HTTPServer::HTTPServer(void){}
HTTPServer::~HTTPServer(void){Server.Close();}

void HTTPServer::Start(int port){
 Port=port;StopRequest=0;//No Stop Request
 if(pthread_create(&ServerMainThreadID,NULL,StartMainThreadProxy,this))Error("HTTP Server","Cannot start thread");
 pthread_detach(ServerMainThreadID);
}

void HTTPServer::Stop(void){StopRequest=1;}



void *HTTPServer::HTTPClientHandler(void*ClientInfo){
 HTTPClientInfo*Info=(HTTPClientInfo*)ClientInfo;

 u8*Buffer=(u8*)malloc(500);
 SocketReceive(Info->Socket,Buffer,500);
 u8*Request=(u8*)malloc(500);

 sscanf((const char *)Buffer,"GET %s",Request);//Extract actual request
 HTTPAnswer(Info->Socket,Request,Info->SADB);

 close(Info->Socket);
 free(Buffer);
 free(Request);

 free(Info);
 pthread_exit(NULL);
}


void *HTTPServer::StartMainThreadProxy(void *context){
 ((HTTPServer *)context)->Main();return NULL;
}

void HTTPServer::Main(void){
 Server.Server(Port,5);
 printf("HTTP Server Started on port %d\n",Port);
 while(1){//Check for new connections
  int Socket=Server.GetConnection();//Get Connection
  if(Socket>=0){//Valid Socket
   HTTPClientInfo*Client=(HTTPClientInfo*)malloc(sizeof(HTTPClientInfo));//Allocate memory, let  the client handler free it
   Client->Socket=Socket;
   Client->SADB=SADB;
   //Start a new thread to handle the request and detatch it
   pthread_t RequestHandler;
   if(pthread_create(&RequestHandler,NULL,HTTPClientHandler,Client))Error("HTTP","Failed to spawn client handler thread");
   pthread_detach(RequestHandler);
  }
  if(StopRequest==1){
   printf("HTTP Server Stopped\n");
   pthread_exit(NULL);
  }
 }
}
