#ifndef __HTTPServer__
#define __HTTPServer__

///Holds information about a single HTTP client
typedef struct{
 int Socket;
 SADBServer*SADB;
}HTTPClientInfo;

///Main HTTP server class
class HTTPServer {
 public:
  HTTPServer(void);
  ~HTTPServer(void);
  void Start(int port=DefaultHTTPPort);///<Start the main thread for the SADB server
  void Stop(void);
  SADBServer*SADB;///<Pointer To the SADB Server monitored by the HTTP Server
 private:
  int StopRequest;///<Boolean Stop Request
  int Port;///<Port Number
  Network Server;///<Handles most Network Related Stuff
  pthread_t ServerMainThreadID;///<pthead object for the main thread
  ///Static function to start the main thread
  ///@param context void casted pointer to a HTTPServer object
  static void *StartMainThreadProxy(void *context);
  void Main(void);///<Main Method for the server thread
  ///Client Handling function
  ///@param ClientInfo void casted pointer to a HTTPClientInfo object
  static void *HTTPClientHandler(void*ClientInfo);
};
#endif 

