void Interpolator::Linear(Timestamp Target){
 SADBObjectStorage *A,*B;

 if(Object->nValues>1){
  if(Index==-1){//first value in the list iu greater than requested timestamp, need to take first two values
   A=Object->Values[0];
   B=Object->Values[1];
  }else if(Index==Object->nValues-1){//last value in the list is smaller, take last 2 values
   A=Object->Values[Object->nValues-2];
   B=Object->Values[Object->nValues-1];
  }else{//Normal case
   A=Object->Values[Index];
   B=Object->Values[Index+1];
  }
 }else if(Object->nValues==1){//list is a single value, not efficient, but shouldn't happen too often
  A=Object->Values[0];
  Data.SetDataType(A->DataType);
  Data.SetDimensions(A->Dimensionality,A->Dimensions);
  for(int i=0;i<A->TotalNumberOfElements;i++)Data.SetDoubleElement(A->GetDoubleElement(i),i);
  return;
 }else{//List is empty
  return;
 }


 //Switch times to milliseconds and shift first one to 0 to prevent overflows
 int BM=B->Time.Millisecond;
 int BS=B->Time.Second;
 BM-=A->Time.Millisecond;
 if(BM<0){
  BM+=1000;
  BS--;
 }
 BS-=A->Time.Second;

 int TM=Target.Millisecond;
 int TS=Target.Second;
 TM-=A->Time.Millisecond;
 if(TM<0){
  TM+=1000;
  TS--;
 }
 TS-=A->Time.Second;
 
 //Convert to milliseconds
 int XA=0;//Time A
 int XB=BS*1000 + BM;//Time B
 int XT=TS*1000 + TM;//Target Time


 if((A->TotalNumberOfElements==B->TotalNumberOfElements)&&(A->Dimensionality==B->Dimensionality)){
  //Not a good check, but let's assume it's valid for now
  Data.SetDataType(A->DataType);
  Data.SetDimensions(A->Dimensionality,A->Dimensions);

  //Will switch all data to to double for processing
  for(int i=0;i<B->TotalNumberOfElements;i++){
   double VA=A->GetDoubleElement(i);
   double VB=B->GetDoubleElement(i);
   double a=(VB-VA)/(XB-XA);
   double b=VA-a*XA;
   Data.SetDoubleElement(a*(double)XT+b,i);
  }


 }



}
