#include "SADB.hpp"

NanoTimer::NanoTimer(void){Start();}
NanoTimer::~NanoTimer(void){}

/// Start the timer
void NanoTimer::Start(void){
 clock_gettime(CLOCK_MONOTONIC,&A);
}

/// Returns the number of nanoseconds elapsed since the timer was started
/// @return nanoseconds
long NanoTimer::Stop(void){
 clock_gettime(CLOCK_MONOTONIC,&B);
 long TA=(long)A.tv_sec*1000000000+A.tv_nsec;
 long TB=(long)B.tv_sec*1000000000+B.tv_nsec;
 return TB-TA;
}

/// Prints the number of nanoseconds elapsed since the timer was started
void NanoTimer::Print(void){
 clock_gettime(CLOCK_MONOTONIC,&B);
 long TA=(long)A.tv_sec*1000000000+A.tv_nsec;
 long TB=(long)B.tv_sec*1000000000+B.tv_nsec;
 printf("%ld\n",TB-TA);
}

/// Prints the inverse (1/x) of number of nanoseconds elapsed since the timer was started, good to measure frequencies
void NanoTimer::PrintInverse(void){
 clock_gettime(CLOCK_MONOTONIC,&B);
 long TA=(long)A.tv_sec*1000000000+A.tv_nsec;
 long TB=(long)B.tv_sec*1000000000+B.tv_nsec;
 printf("%lf\n",(double)1/((double)(TB-TA)/1000000000));
}



