//Configuration Defines
#define POSIX //Comment this out if not on a posix system
#define DefaultSADBPort	8081
#define SADBAddress	"127.0.0.1"
#define DefaultHTTPPort	8082
#define HTTPData 	"HTTPData"

#define ARMADILLO

//Common C Includes
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <ctype.h>
#include <fcntl.h>

#include <netinet/tcp.h>
#include <sys/sysinfo.h>

//Posix Includes
#ifdef POSIX
#include <sys/time.h>
#include <sys/stat.h>
#include <pthread.h>
#endif

//Armadillo Includes
#ifdef ARMADILLO
#include <armadillo>
//using namespace arma;
#endif

//Network Includes, most are POSIX
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

//RAM Checker
/*
#include "MemoryController.hpp"
extern MemoryController Memory;//Global object that keeps track of memory
#include "Memory-Hijack.hpp"
*/


#include "NanoTimer.hpp"

#include "Basics.hpp"
#include "Network.hpp"
#include "NetPackets.hpp"

#include "SADBRequest.hpp"		// Request String Processing
#include "SADBObjectStorage.hpp"	// Value storage for SADBObject
#include "SADBObject.hpp"		// Object storage for the Server
#include "Interpolator.hpp"		// Object value intrpolation

#include "SADBCategory.hpp"		// Category Class for use by the server
#include "SADBServer.hpp"
#include "HTTPServer.hpp"

