#ifndef __SADBCategory__
#define __SADBCategory__

class SADBCategory {
 public:
  SADBCategory(void);
  ~SADBCategory(void);
  void Initialize(void);
  void Free(void);

  int SetName(const char * name);
  int SetDescription(const char * desc);

  int AddObject(u64 ID);
  int RemoveObject(u64 ID);

  /// Human Readable Category Name
  u8 * Name;
  /// Human Readable Category Description
  u8 * Description;
  /// List of object IDs in this category
  u64 * ObjectIDs;
  /// Number of objects in this category
  int nObjects;
  /// Unique ID of the category
  u64 ID;

  /// Mutex for data allocation
  pthread_mutex_t DataAllocationMutex;
  /// Mutex for information strings
  pthread_mutex_t InfoMutex;

 private:

};
#endif 

