#ifndef __SADBObject__
#define __SADBObject__



class SADBObject {
 public:
  SADBObject(void);
  ~SADBObject(void);
  void Initialize(void);
  void Free(void);

  int SetName(const char * name);
  int SetDescription(const char * desc);

  void NewValue(u32 Dimensionality,u32*Dimensions,u8 DataType,u8*Data,u64 Second,u16 Millisecond);
  int AllocateValue(void);
  int RemoveValue(int index);

  int FindTimestampIndex(Timestamp*Target);
  void LatestTimestamp(Timestamp*T);
  void NextTimestamp(Timestamp*Target,Timestamp*T);
  void PreviousTimestamp(Timestamp*Target,Timestamp*T);
  
  
  /// Number of stored values 
  int nValues;
  /// List of pointers to SADBStorage objects
  SADBObjectStorage ** Values;
  /// Object ID on the blackboard
  u64 ID;
  /// Human Readable Object Name
  u8 * Name;
  /// Human Readable Object Description
  u8 * Description;
  /// Mutex for data allocation
  pthread_mutex_t DataAllocationMutex;
  /// Mutex for information strings
  pthread_mutex_t InfoMutex;

 private:


};
#endif 

