#ifndef __SADBObjectStorage__
#define __SADBObjectStorage__



class SADBObjectStorage {
 public:
  SADBObjectStorage(void);
  ~SADBObjectStorage(void);
  void Initialize(void);
  void Free(void);

  void SetDataType(enum BODataType);
  int SetDimensionsf(int D,...);
  int SetDimensions(int D,u32*Ds);

  void SetElement(void * Value,...);
  void GetElement(void * Value,...);

  double GetDoubleElement(int Index);
  void SetDoubleElement(double Value,int Index);

  void SetTimestamp(Timestamp time);
  void SetTimestamp(u64 Second,u16 Millisecond);

  
  void Information(void);//For debugging purposes

  /// Pointer to Memory Location of the data
  void * Data;
  /// Dimensionality of the data (number of dimensiosns)
  int Dimensionality;
  /// Dimensions of the data
  u32 * Dimensions;
  /// Total number of elements (Product of all dimensions)
  int TotalNumberOfElements;
  /// Data Type
  enum BODataType DataType;
  /// Element Size (in bytes)
  int ElementSize;
  /// Timestamp of the data
  Timestamp Time;  
  /// Mutex for this value
  pthread_mutex_t Mutex;
 private:


};
#endif 

