#ifndef __SADBRequest__
#define __SADBRequest__

class SADBServer;

/// Used internally to process Set requests
class SADBRequest {
 public:
  SADBRequest(void);
  ~SADBRequest(void);
  void Initialize(void);
  void Free(void);
  void SetBoard(SADBServer*board);

  void Process(u8*String,u64**List,int*nObjects);

  /// Basic Functions
  void Union(u64 * ListA,int nElementsA,u64 * ListB,int nElementsB,u64 ** Output,int * nElementsOutput);
  void Intersection(u64 * ListA,int nElementsA,u64 * ListB,int nElementsB,u64 ** Output,int * nElementsOutput);
  void Complement(u64 * ListA,int nElementsA,u64 ** Output,int * nElementsOutput);

  /// Number of values in the list
  int nIDs;
  /// List of IDs
  u64 * IDs;
  /// SADB server being worked on
  SADBServer * Board;
 private:
  int Valid(char *S);

};
#endif 

