#include "SADB-Server/SADB.hpp"

//Global Variables
SADBServer SADB;
HTTPServer HTTP;

void CleanUp(void){
 //SADB.Stop();
 HTTP.Stop();
}

void Help(void){
 printf("Usage:\tServer [-p SADBPort] [-http HTTPPort]\n");
 exit(0);
}
     
int main(int nArgs,char*Args[]){
 int HTTPPort=DefaultHTTPPort;
 int SADBPort=DefaultSADBPort;
 if(nArgs>1){//There are cmd line args
  for(int i=1;i<nArgs;i++){
   if(Args[i][0]=='-'){
    if((strcmp(Args[i],"-h")==0)||(strcmp(Args[i],"--help")==0))Help();
    if((strcmp(Args[i],"-p")==0)&&(i<nArgs-1)){
     SADBPort=atoi(Args[i+1]);
     if((SADBPort<0)||(SADBPort>65535))SADBPort=DefaultSADBPort;
    }
    if((strcmp(Args[i],"-http")==0)&&(i<nArgs-1)){
     HTTPPort=atoi(Args[i+1]);
     if((HTTPPort<0)||(HTTPPort>65535))HTTPPort=DefaultHTTPPort;
    }
   }
  }
 }
 
 atexit(CleanUp);//Call on normal exit

 HTTP.SADB=&SADB;
 SADB.Start(SADBPort);
 HTTP.Start(HTTPPort);

 while(1)usleep(500000);

 pthread_exit(NULL);
}
