#include "../SADB-Client/SADB.h"
using namespace SADB;

int main(void){
 Blackboard Board;
 int r=Board.ConnectToServer("127.0.0.1",8081);
 printf("%d\n",r);
 //Create the 4 categories

 //Position
 SADBu64 Position=Board.CreateCategory();
 Board.SetCategoryName(Position,"Position");
 Board.SetCategoryDescription(Position,"Contains position vectors in the form p=(x,y)");

 //Color
 SADBu64 Color=Board.CreateCategory();
 Board.SetCategoryName(Color,"Color");
 Board.SetCategoryDescription(Color,"Contains RGB formatted color vectors in the form c=(r,g,b)");

 //Size
 SADBu64 Size=Board.CreateCategory();
 Board.SetCategoryName(Size,"Size");
 Board.SetCategoryDescription(Size,"Contains scalar sizes P=(x,y)");

 //Ball1 Category
 SADBu64 Ball1=Board.CreateCategory();
 Board.SetCategoryName(Ball1,"Ball1");
 Board.SetCategoryDescription(Ball1,"Properties of ball 1");


 //Create the 3 objects

 BlackboardObject p1;
 p1.SetBlackboard(&Board);
 p1.AddToBlackboard();
 p1.SetDataType(BOFloat);
 p1.SetDimensionsf(1,2);//1 dimensional vector, 2 components
 p1.SetName("Ball1 Position");
 p1.SetDescription("Position of the ball 1");

 BlackboardObject c1;
 c1.SetBlackboard(&Board);
 c1.AddToBlackboard();
 c1.SetDataType(BOByte);//We only need 8bits per color component for RGB24
 c1.SetDimensionsf(1,3);//1 dimensional vector, 3 components
 c1.SetName("Ball1 Color");
 c1.SetDescription("Color of the ball 1");

 BlackboardObject s1;
 s1.SetBlackboard(&Board);
 s1.AddToBlackboard();
 s1.SetDataType(BOFloat);//We only need 8bits per color component for RGB24
 s1.SetDimensionsf(1,1);//Scalar = 1 dimensional vector, 1 component
 s1.SetName("Ball1 size");
 s1.SetDescription("Size of the ball 1");

 // Place the objects in the proper categories
 p1.AddToCategory("Position");
 p1.AddToCategory("Position");
 p1.AddToCategory("Ball1");
 c1.AddToCategory("Color");
 c1.AddToCategory("Ball1");
 s1.AddToCategory("Size");
 s1.AddToCategory("Ball1");

 // Populate the object with data (let's assume that this is a measurement)
 p1.SetTimestampNow();
 p1.SetFloat(1.5, 0);
 p1.SetFloat(2.83, 1);

 c1.SetTimestampNow();
 c1.SetByte(0xFF,0);
 c1.SetByte(0xFF,1);
 c1.SetByte(0x00,2);

 s1.SetTimestampNow();
 s1.SetFloat(5.74,0);
 
 // Send the object to the blackboard
 p1.Send();
 c1.Send();
 s1.Send();
 

 
 
 for(int i=0;i<10;i++){ // Populate the object again to get multiple timestamps
  sleep(1);
  p1.SetTimestampNow();
  p1.SetFloat(1.5, 0);
  p1.SetFloat(2.83, 1);

  c1.SetTimestampNow();
  c1.SetByte(0xFF,0);
  c1.SetByte(0xFF,1);
  c1.SetByte(0x00,2);

  s1.SetTimestampNow();
  s1.SetFloat(5.74,0);

  // Send the object to the blackboard
  p1.Send();
  c1.Send();
  s1.Send();
   
 }

}
