#include "../SADB-Client/SADB.h"
using namespace SADB;

void Callback(Blackboard*Board,SADBu64 Trigger){
 printf("Received Trigger: %ld\n",(long int)Trigger);
}

int main(void){
 Blackboard Board;
 Board.ConnectToServer("127.0.0.1");

 
 //Create 2 objects
 BlackboardObject p1;
 p1.Create(&Board,"Trigger object 1","Test Object 1 for triggering",BOFloat);
 p1.SetDimensionsf(1,2);
 BlackboardObject p2;
 p2.Create(&Board,"Trigger object 1","Test Object 1 for triggering",BOByte);
 p2.SetDimensionsf(2,2,2);

 //Put some data into first object
 p1.Time.Second=0;p1.Time.Millisecond=5;
 p1.SetFloat(1.5,0);p1.SetFloat(2.83,1);
 p1.Send();
 p1.Time.Second=1;p1.Time.Millisecond=6;
 p1.SetFloat(2.4,0);p1.SetFloat(3.56,1);
 p1.Send();
 p1.Time.Second=2;p1.Time.Millisecond=7;
 p1.SetFloat(3.3,0);p1.SetFloat(4.36,1);
 p1.Send();
 p1.KeepOnlyLatestValues(3);
 //Put some data into second object
 p2.Time.Second=0;p1.Time.Millisecond=5;
 p2.SetByte(1,0,0);p2.SetByte(2,1,0);
 p2.SetByte(3,0,1);p2.SetByte(4,1,1);
 p2.Send();
 p2.Time.Second=1;p2.Time.Millisecond=6;
 p2.SetByte(5,0,0);p2.SetByte(6,1,0);
 p2.SetByte(7,0,1);p2.SetByte(8,1,1);
 p2.Send();
 p2.Time.Second=2;p2.Time.Millisecond=7;
 p2.SetByte(9,0,0);p2.SetByte(10,1,0);
 p2.SetByte(11,0,1);p2.SetByte(12,1,1);
 p2.Send();
 p2.KeepOnlyLatestValues(3);
 
 
 
 BlackboardTrigger Trigger;
 //Trigger.SetProgram(Program,strlen(Program));
 Trigger.LoadProgram("Data/test.bettertrigger.lua");
 Trigger.SetnTargets(2);
 Trigger.SetTarget(0,p1.ID);
 Trigger.SetTarget(1,p2.ID);
 Trigger.SetBlackboard(&Board);
 Trigger.SetPeriod(1000);
 Trigger.SetCallback(&Callback);
 Trigger.Start();
 
 while(1);
}
