#include "../SADB-Client/SADB.h"
using namespace SADB;

int main(void){
 Blackboard Board;
 Board.ConnectToServer("127.0.0.1");
 
 //Create an object with 100 values at different timestamps

 BlackboardObject Obj;
 Obj.Create(&Board,"Test Object",BOInteger);
 Obj.SetDimensionsf(1,3);//3 component vector
 
 for(int i=0;i<100;i++){
  Obj.SetTimestampNow();
  Obj.SetInteger(i,0);Obj.SetInteger(i+1,1);Obj.SetInteger(i+2,2);
  Obj.Send();
  usleep(10000);//leave some time between values
 }

 //Test to make sure the GetValueAtNextTimestamp and GetValueAtPreviousTimestamp work properly

 BlackboardObject Receiver;
 Receiver.Create(&Board,"Test Object");//Will fetch the ID from the blackboard
 
 Timestamp Time;

 //Chronological order
 for(int i=0;i<105;i++){
  Receiver.GetValueAtNextTimestamp(&Time);
  printf("Value after %lf is at %lf: [%d %d %d]\n",Time.Get(),Receiver.Time.Get(),Receiver.GetInteger(0),Receiver.GetInteger(1),Receiver.GetInteger(2));
  Time.Second=Receiver.Time.Second;
  Time.Millisecond=Receiver.Time.Millisecond;
 }

 printf("####################################\n");

 //reverse order
 Time.Now();
 for(int i=0;i<105;i++){
  Receiver.GetValueAtPreviousTimestamp(&Time);
  printf("Value before %lf is at %lf: [%d %d %d]\n",Time.Get(),Receiver.Time.Get(),Receiver.GetInteger(0),Receiver.GetInteger(1),Receiver.GetInteger(2));
  Time.Second=Receiver.Time.Second;
  Time.Millisecond=Receiver.Time.Millisecond;
 }

 // Now test the CSV export function
 Receiver.ExportAllValuesToCSV("output.csv");
 Receiver.ExportRaw("output.raw");


}
