#include "../SADB-Client/SADB.h"
using namespace SADB;

int main(void){
 Blackboard Board;
 Board.ConnectToServer("127.0.0.1");

 //Simple manually created string table
 BlackboardObject O;

 
 O.Create(&Board,"Timestamp Test","Multiple timestamp access test objects",BOInteger);
 O.SetDimensionsf(1,1);//scalar int value

 
 //Send a bunch of values at different timestamps
 for(int t=0;t<100;t++){
  O.Time.Second=t;O.Time.Millisecond=0;
  O.SetInteger(t,0);
  O.Send();
 }
 
 
 Timestamp T;
 
 //Get next timestamps from 50
 T.Second=50;T.Millisecond=0;
 printf("Getting increasing timestamps from 50\n");
 for(int t=0;t<10;t++){
  O.GetNextTimestamp(&T,&T);
  T.Print();printf("\n");
 }
 
 //Get previous timestamps from 50
 printf("Getting decreasing timestamps from 50\n");
 T.Second=50;T.Millisecond=0;
 for(int t=0;t<10;t++){
  O.GetPreviousTimestamp(&T,&T);
  T.Print();printf("\n");
 }
 
 
 printf("Getting nearest timestamp from 31.25: ");
 T.Second=31;T.Millisecond=250;
 O.GetNearestTimestamp(&T,&T);
 T.Print();printf("\n");
 
 printf("Getting nearest timestamp from 31.5: ");
 T.Second=31;T.Millisecond=500;
 O.GetNearestTimestamp(&T,&T);
 T.Print();printf("\n");
 
 printf("Getting nearest timestamp from 31.75: ");
 T.Second=31;T.Millisecond=750;
 O.GetNearestTimestamp(&T,&T);
 T.Print();printf("\n");
 
 
}
