#include "../SADB-Client/SADB.h"
using namespace SADB;

int main(void){
 Blackboard Board;
 Board.ConnectToServer("127.0.0.1");

 //Create an object

 BlackboardObject p1;
 p1.SetBlackboard(&Board);
 p1.AddToBlackboard();
 p1.SetDataType(BOFloat);
 p1.SetDimensionsf(1,1);//1 dimensional scalar
 p1.SetName("Ball1 Position");
 p1.SetDescription("Position of the ball 1");
 p1.Time.Millisecond=0;//Keep milliseconds fixed to 0


 // Populate the object with data (let's assume that this is a measurement)
 p1.Time.Second=10;
 p1.SetFloat(0.0,0);
 p1.Send();

 p1.Time.Second=20;
 p1.SetFloat(10.0,0);
 p1.Send();


 Timestamp Target;
 Target.Millisecond=0;

 BlackboardObject p2;
 p2.SetBlackboard(&Board);
 p2.GetByName("Ball1 Position");


 Target.Second=5;
 p2.GetValueAtTimestamp(&Target);
 p2.Information();//should be -5

 Target.Second=10;
 p2.GetValueAtTimestamp(&Target);
 p2.Information();//should be 0

 Target.Second=15;
 p2.GetValueAtTimestamp(&Target);
 p2.Information();//should be 5

 Target.Second=20;
 p2.GetValueAtTimestamp(&Target);
 p2.Information();//should be 10

 Target.Second=25;
 p2.GetValueAtTimestamp(&Target);
 p2.Information();//should be 15

 Target.Second=15;
 Target.Millisecond=500;
 p2.GetValueAtTimestamp(&Target,1,10);
 p2.Information();//should be 5.5


}
