#include "../SADB-Client/SADB.h"
using namespace SADB;

int main(void){
 Blackboard Board;
 Board.ConnectToServer("127.0.0.1");

 printf("String List Test\n\n\n");
 
 //First test, not reallocating the size
 BlackboardObject StrA;
 StrA.SetBlackboard(&Board);
 StrA.Create(&Board,"String Matrix Test A","Multiple string storage test",BOByte);
 StrA.SetDimensionsf(2,14,15);

 for(int i=0;i<1000000;i++){
  printf("Iteration %d\n",i);
  StrA.SetTimestampNow();
  StrA.SetStringElement("String A",0);
  StrA.SetStringElement("String B",1);
  StrA.SetStringElement("String C",2);
  StrA.SetStringElement("String D",3);
  StrA.SetStringElement("String E",4);
  StrA.SetStringElement("String F",5);
  StrA.SetStringElement("String G",6);
  StrA.SetStringElement("String H",7);
  StrA.SetStringElement("String I",8);
  StrA.SetStringElement("abcdefghijklmn",9);//the \0 remains
  StrA.SetStringElement("abcdefghijklmno",10);//THis is exactly 15 bytes (the \0 will get truncated)
  StrA.SetStringElement("abcdefghijklmnop",11);//truncates \0 and final character
  StrA.SetStringElement("String M",12);
  StrA.SetStringElement("String N",13);
  StrA.Send();
  
  for(int j=0;j<14;j++){//Test the getstringelement as well
   char * Str=StrA.GetStringElement(j);
   printf(" %d-> %s\n",j,Str);
   free(Str);
  }
  

 }
 
 //Second test, reallocating the size each iteration
 BlackboardObject StrB;
 StrB.SetBlackboard(&Board);
 StrB.Create(&Board,"String Matrix Test B","Multiple string storage test",BOByte);


 for(int i=0;i<1000000;i++){
  printf("Iteration %d\n",i);
  StrB.SetDimensionsf(2,14,15);
  StrB.SetTimestampNow();
  StrB.SetStringElement("String A",0);
  StrB.SetStringElement("String B",1);
  StrB.SetStringElement("String C",2);
  StrB.SetStringElement("String D",3);
  StrB.SetStringElement("String E",4);
  StrB.SetStringElement("String F",5);
  StrB.SetStringElement("String G",6);
  StrB.SetStringElement("String H",7);
  StrB.SetStringElement("String I",8);
  StrB.SetStringElement("abcdefghijklmn",9);//the \0 remains
  StrB.SetStringElement("abcdefghijklmno",10);//THis is exactly 15 bytes (the \0 will get truncated)
  StrB.SetStringElement("abcdefghijklmnop",11);//truncates \0 and final character
  StrB.SetStringElement("String M",12);
  StrB.SetStringElement("String N",13);
  StrB.Send();
  
  for(int j=0;j<14;j++){//Test the getstringelement as well
   char * Str=StrB.GetStringElement(j);
   printf(" %d-> %s\n",j,Str);
   free(Str);
  }
  
 }
 
}