#include "../SADB-Client/SADB.h"
#define nMaxObjects 300
#define nSamples 1500
using namespace SADB;

long StartTime;

void Timer_Start(void){
 struct timespec T;
 clock_gettime(CLOCK_MONOTONIC,&T);
 StartTime=(long)T.tv_sec*1000000000+T.tv_nsec;
}

//Get the time in usec
int Timer_Stop(void){
 struct timespec T;
 clock_gettime(CLOCK_MONOTONIC,&T);
 long TB=(long)T.tv_sec*1000000000+T.tv_nsec;
 return (TB-StartTime)/1000;
}






int main(void){
 Blackboard Board;
 Board.ConnectToServer("192.168.1.10");
 FILE *Data=fopen("Measure","w");//Open a file for output
 

 //for(int nObjects=nMaxObjects;nObjects>0;nObjects-=2){
 for(int nObjects=10;nObjects>0;nObjects-=2){
  BlackboardObject O[nMaxObjects];
  printf("nObjects: %d\n",nObjects);
  //Create blackboard objects

  for(int i=0;i<nObjects;i++){
   char Name[10];
   sprintf(Name,"O-%04d",i);
   O[i].Create(&Board,Name,"",BOFloat);
   O[i].SetDimensionsf(2,600,4);//4x4 matrix
  }
 
  int Write[nSamples];for(int i=0;i<nSamples;i++)Write[i]=0;
  int Read[nSamples];for(int i=0;i<nSamples;i++)Read[i]=0;
  //Update the objects on the blackboard 1000 times
  for(int i=0;i<nSamples;i++){
   
   //Set Timestamps and put random data
   for(int o=0;o<nObjects;o++){
    O[o].Time.Second=i;
    for(int j=0;j<O[o].Dimensions[0];j++)for(int k=0;k<O[o].Dimensions[1];k++)O[o].SetFloat(rand()%100,j,k);
   }
   
   //Send the objects and measure
   Timer_Start();
   for(int o=0;o<nObjects;o++)O[o].Send();
   Write[i]=Timer_Stop();
   //printf("W %d\n",Write[i]);
   //Read the objects and measure
   Timer_Start();
   for(int o=0;o<nObjects;o++)O[o].GetLatestValue();
   Read[i]=Timer_Stop();
   //printf("R %d\n",Read[i]);
   //Remove values from board to save ram
   //for(int o=0;o<nObjects;o++)O[o].RemoveOldestValue();
 
   
  }

  //Remove objects from board to save ram
  //for(int o=0;o<nObjects;o++)Board.DeleteObject(O[o].ID);
 
  //Compute some stats
  //Average
  float WriteAvg=0;
  float ReadAvg=0;
  for(int i=0;i<nSamples;i++){
   WriteAvg+=(float)Write[i]/nSamples;
   ReadAvg+=(float)Read[i]/nSamples;
  }
  //Standard Deviation
  float WriteStd=0;
  float ReadStd=0;
  for(int i=0;i<nSamples;i++){
   WriteStd+=pow((float)Write[i]-WriteAvg,2)/nSamples;
   ReadStd+=pow((float)Read[i]-ReadAvg,2)/nSamples;
  }
  WriteStd=sqrt(WriteStd);
  ReadStd=sqrt(ReadStd);
  
  fprintf(Data,"%d\t%f\t%f\t%f\t%f\n",nObjects,WriteAvg,WriteStd,ReadAvg,ReadStd);
  printf("%d\t%f\t%f\t%f\t%f\n",nObjects,WriteAvg,WriteStd,ReadAvg,ReadStd);
 }
 
 
 
 
 
 fclose(Data);
}
